# Welcome to Click

Click is a Python package for creating beautiful command line interfaces in a composable way with as little code as necessary. It’s the “Command Line Interface Creation Kit”. It’s highly configurable but comes with sensible defaults out of the box.

It aims to make the process of writing command line tools quick and fun while also preventing any frustration caused by the inability to implement an intended CLI API.

Click in three points:

- arbitrary nesting of commands

- automatic help page generation

- supports lazy loading of subcommands at runtime

What does it look like? Here is an example of a simple Click program:

    import click

    @click.command()
    @click.option('--count', default=1, help='Number of greetings.')
    @click.option('--name', prompt='Your name',
                  help='The person to greet.')
    def hello(count, name):
        """Simple program that greets NAME for a total of COUNT times."""
        for x in range(count):
            click.echo(f"Hello {name}!")

    if __name__ == '__main__':
        hello()

And what it looks like when run:

    $ python hello.py --count=3
    Your name: John
    Hello John!
    Hello John!
    Hello John!

It automatically generates nicely formatted help pages:

    $ python hello.py --help
    Usage: hello.py [OPTIONS]

      Simple program that greets NAME for a total of COUNT times.

    Options:
      --count INTEGER  Number of greetings.
      --name TEXT      The person to greet.
      --help           Show this message and exit.

You can get the library directly from PyPI:

    pip install click

## Documentation

This part of the documentation guides you through all of the library’s usage patterns.

- Why Click?
  - Why not Argparse?
  - Why not Docopt etc.?
  - Why Hardcoded Behaviors?
  - Why No Auto Correction?
- Quickstart
  - Install
  - Examples
  - Basic Concepts - Creating a Command
  - Echoing
  - Nesting Commands
  - Registering Commands Later
  - Adding Parameters
  - Switching to Setuptools
- Virtualenv
  - Why Use Virtualenv?
  - How to Use Virtualenv
- Setuptools Integration
  - Introduction
  - Testing The Script
  - Scripts in Packages
- Parameters
  - Options
  - Arguments
  - Parameter Names
  - Parameter Types
  - How to Implement Custom Types
- Options
  - Name Your Options
  - Basic Value Options
  - Multi Value Options
  - Tuples as Multi Value Options
  - Multiple Options
  - Counting
  - Boolean Flags
  - Feature Switches
  - Choice Options
  - Prompting
  - Password Prompts
  - Dynamic Defaults for Prompts
  - Callbacks and Eager Options
  - Yes Parameters
  - Values from Environment Variables
  - Multiple Values from Environment Values
  - Other Prefix Characters
  - Range Options
  - Callbacks for Validation
  - Optional Value
- Arguments
  - Basic Arguments
  - Multiple Arguments
  - Argument Escape Sequences
  - Environment Variables
- Commands and Groups
  - Callback Invocation
  - Passing Parameters
  - Nested Handling and Contexts
  - Decorating Commands
  - Group Invocation Without Command
  - Custom Multi Commands
  - Merging Multi Commands
  - Multi Command Chaining
  - Multi Command Pipelines
  - Overriding Defaults
  - Context Defaults
  - Command Return Values
- User Input Prompts
  - Option Prompts
  - Input Prompts
  - Confirmation Prompts
- Handling Files
  - File Arguments
  - File Path Arguments
  - File Opening Behaviors
- Documenting Scripts
  - Help Texts
  - Documenting Arguments
  - Preventing Rewrapping
  - Truncating Help Texts
  - Meta Variables
  - Command Short Help
  - Command Epilog Help
  - Help Parameter Customization
- Complex Applications
  - Basic Concepts
  - Building a Git Clone
  - Lazily Loading Subcommands
- Advanced Patterns
  - Command Aliases
  - Parameter Modifications
  - Token Normalization
  - Invoking Other Commands
  - Callback Evaluation Order
  - Forwarding Unknown Options
  - Global Context Access
  - Detecting the Source of a Parameter
  - Managing Resources
- Testing Click Applications
  - Basic Testing
  - File System Isolation
  - Input Streams
- Utilities
  - Printing to Stdout
  - ANSI Colors
  - Pager Support
  - Screen Clearing
  - Getting Characters from Terminal
  - Waiting for Key Press
  - Launching Editors
  - Launching Applications
  - Printing Filenames
  - Standard Streams
  - Intelligent File Opening
  - Finding Application Folders
  - Showing Progress Bars
- Shell Completion
  - Enabling Completion
  - Custom Type Completion
  - Overriding Value Completion
  - Adding Support for a Shell
- Exception Handling
  - Where are Errors Handled?
  - What if I don’t want that?
  - Which Exceptions Exist?
- Unicode Support
  - Surrogate Handling
- Windows Console Notes
  - Unicode Arguments
  - Unicode Output and Input

## API Reference

If you are looking for information on a specific function, class, or method, this part of the documentation is for you.

- API
  - Decorators
  - Utilities
  - Commands
  - Parameters
  - Context
  - Types
  - Exceptions
  - Formatting
  - Parsing
  - Shell Completion
  - Testing

## Miscellaneous Pages

- click-contrib
  - Third-party projects
- Upgrading To Newer Releases
  - Upgrading to 7.0
  - Upgrading to 3.2
  - Upgrading to 2.0
- BSD-3-Clause License
- Changes
  - Version 8.1.8
  - Version 8.1.7
  - Version 8.1.6
  - Version 8.1.5
  - Version 8.1.4
  - Version 8.1.3
  - Version 8.1.2
  - Version 8.1.1
  - Version 8.1.0
  - Version 8.0.4
  - Version 8.0.3
  - Version 8.0.2
  - Version 8.0.1
  - Version 8.0.0
  - Version 7.1.2
  - Version 7.1.1
  - Version 7.1
  - Version 7.0
  - Version 6.7
  - Version 6.6
  - Version 6.4
  - Version 6.3
  - Version 6.2
  - Version 6.1
  - Version 6.0
  - Version 5.1
  - Version 5.0
  - Version 4.1
  - Version 4.0
  - Version 3.3
  - Version 3.2
  - Version 3.1
  - Version 3.0
  - Version 2.6
  - Version 2.5
  - Version 2.4
  - Version 2.3
  - Version 2.2
  - Version 2.1
  - Version 2.0
  - Version 1.1
  - Version 1.0